unit RoomStuff;

interface

uses Windows, Graphics, SysUtils;

type
  TRoom = record
    left, right, leftceiling, rightceiling, leftfloor, rightfloor: Integer;
    roomtype: Integer;
  end;

  TMetaRoomData = record
    metaroom_id: Integer;
    x, y, width, height: Integer;

    norooms: Integer;
    rooms: array[0..1000] of TRoom;
  end;

  TMetaRoom = class
    data: TMetaRoomData;
    backgroundfile: string;

    procedure Open(fname: string);
    procedure Save(fname: string);
  end;

implementation

procedure TMetaRoom.Open(fname: string);
var
  F, j: Integer;
begin
  f := FileOpen(fname, fmOpenRead);
  FileRead(F, data, sizeof(TMetaRoomData));
  FileRead(F, j, 4);
  SetLength(backgroundfile, j);
  FileRead(F, (@backgroundfile[1])^, j);
  FileClose(f);
end;

procedure TMetaRoom.Save(fname: string);
var
  F, j: Integer;
begin
  f := FileCreate(fname);
  FileWrite(F, data, sizeof(TMetaRoomData));
  j := Length(backgroundfile);
  FileWrite(F, j, 4);
  FileWrite(F, PChar(backgroundfile)^, j);
  FileClose(f);
end;

end.
