unit unitCAOSReference;

// TCAOSRefForm : CAOS Reference

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  unitChildForm, StdCtrls, ExtCtrls;

type
  TCAOSRefForm = class(TForm)
    ComboBox1: TComboBox; ComboBox2: TComboBox; Panel1: TPanel; Memo1: TMemo;

    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  end;

var
  CAOSRefForm: TCAOSRefForm;

implementation

uses unitSyntaxInformation, unit1;

{$R *.DFM}

procedure TCAOSRefForm.FormCreate(Sender: TObject);
begin
  inherited;
  ClientWidth := 255;
end;

procedure TCAOSRefForm.ComboBox1Change(Sender: TObject);
var
  i: integer;
  q: string;
begin
  ComboBox2.Items.Clear;

  for i := 1 to syntaxdata.count do begin
    if (syntaxdata.keywords[i].ktype = ctCommand) = (ComboBox1.ItemIndex = 0) then begin
      q := syntaxdata.keywords[i].name;
      if ComboBox1.ItemIndex > 1 then begin
        if syntaxdata.keywords[i].ktype = GrabType(ComboBox1.Text) then ComboBox2.Items.Add(q);
      end else ComboBox2.Items.Add(q);
    end;
  end;
end;

procedure TCAOSRefForm.ComboBox2Change(Sender: TObject);
var
  dat: TKeywordInfo;
  i: Integer;
begin
  if ComboBox2.ItemIndex = -1 then Exit;

  if ComboBox1.ItemIndex = 0 then dat := syntaxdata.GetKeywordData(ComboBox2.Text, ctCommand)
  else dat := syntaxdata.GetKeywordData(ComboBox2.Text, ctNotCommand);
  
  Assert(dat <> nil, 'syntaxdata::GetKeywordData returned nil for CAOS ref');

  Memo1.Clear;
  Memo1.Lines.Add('Keyword: ' + dat.name);
  Memo1.Lines.Add('Long Desc: ' + dat.longdesc);
  Memo1.Lines.Add('Short Desc: ' + dat.shortdesc);
  Memo1.Lines.Add('Return Type: ' + typetostring(dat.ktype));
  Memo1.Lines.Add('');
  Memo1.Lines.Add('It has ' + IntToStr(dat.noparams) + ' parameters.');
  for i := 1 to dat.noparams do begin
    Memo1.Lines.Add('');
    Memo1.Lines.Add('Param ' + IntToStr(i) + ' is named ' + dat.paramnames[i] + ' and of type ' + typetostring(dat.paramtypes[i]) + '.');
  end;
  Memo1.Lines.Add('');
end;

procedure TCAOSRefForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if (HostDockSite is TPanel) then ZeusMainForm.ShowDockPanel(HostDockSite as TPanel, False, nil);
    
  Action := caHide;
end;

end.
