unit unitBLKViewer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  unitChildForm, BLKClasses, ExtCtrls, Menus;

type
  TBLKViewerForm = class(TMDIChildForm)
    PaintBox1: TPaintBox; MainMenu1: TMainMenu; Tools1: TMenuItem; ExporttoBMP1: TMenuItem; SaveDialog1: TSaveDialog;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure ExporttoBMP1Click(Sender: TObject);
  public
    data: TBLKFile;

    procedure Open(fname: string); override;
  end;

var
  BLKViewerForm: TBLKViewerForm;

implementation

uses Unit1;

{$R *.DFM}

procedure TBLKViewerForm.Open(fname: string); // open ze existing file
begin
  inherited;

  data.Open(fname);
  PaintBox1.Width := data.TotalWidth;
  PaintBox1.Height := data.TotalHeight;
  PaintBox1.Invalidate;
end;

procedure TBLKViewerForm.FormCreate(Sender: TObject);
begin
  inherited;

  data := TBLKFile.Create;
end;

procedure TBLKViewerForm.FormDestroy(Sender: TObject);
begin
  inherited;

  data.Free;
end;

procedure TBLKViewerForm.PaintBox1Paint(Sender: TObject);
begin
  data.Paint(PaintBox1.Canvas);
end;

procedure TBLKViewerForm.ExporttoBMP1Click(Sender: TObject);
var
  bitmap: TBitmap;
begin
  // muhwahahahahahahahahahahahaha - export to bitmap
  if not SaveDialog1.Execute then Exit;

  bitmap := TBitmap.Create;
  try
    bitmap.width := data.TotalWidth;
    bitmap.height := data.TotalHeight;
    data.Paint(bitmap.canvas);
    bitmap.SaveToFile(SaveDialog1.filename);
  finally
    bitmap.Free;
  end;
end;

initialization
  RegisterEditor('Background Files', 'blk', '', TBLKViewerForm);
end.
