unit unitCatalogueForm;

// TCatalogueEditorForm : Catalogue Editor

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, unitChildForm, StdCtrls, CAOSSyntaxMemo;

type
  TCatalogueEditorForm = class(TMDIChildForm)
    Memo1: TSyntaxMemo;

    procedure Memo1FormatLine(I: Integer; const S: String; var F: TFormatLineArray);
    procedure FormCreate(Sender: TObject);
  public
    modified: boolean;

    function IsFileBased: Boolean; override; // are we insane?

    procedure New; override; // make ze new file
    procedure Open(fname: string); override; // open ze existing file
    procedure Save; override; // save ze file
  end;

var
  CatalogueEditorForm: TCatalogueEditorForm;
  green, purp: TFont;

implementation

uses Unit1;

{$R *.DFM}

function TCatalogueEditorForm.IsFileBased: Boolean;
begin
  Result := True;
end;

procedure TCatalogueEditorForm.New;
begin
  inherited;
  modified := false;
end;

procedure TCatalogueEditorForm.Open(fname: string);
begin
  inherited;
  Memo1.Lines.LoadFromFile(filename);
  modified := false;
end;

procedure TCatalogueEditorForm.Save;
begin
  if filename = '' then begin SaveAs; Exit; end;
  modified := false;
  Memo1.Lines.SaveToFile(filename);
end;

procedure TCatalogueEditorForm.Memo1FormatLine(I: Integer; const S: String;
  var F: TFormatLineArray);
var
  nottag: Boolean;
  p: Integer;
begin
  nottag := false; p := Pos('TAG', s);
  if p <> 1 then begin nottag := true; p := Pos('ARRAY', s); end;
  if p = 1 then begin
    F[0].Start := 1;
    F[0].Font := purp;

    if nottag then F[0].Length := 5
    else F[0].Length := 3;

    // fixme: I can't be bothered to implement comments here now
    {nottag := true;} Exit;
  end {else nottag := false}; // now nottag = starts with tag thingie

  // fixme: we should use the tokeniser here! this will color-code even if the
  // '#' character is inside a string!

  p := Pos('#', s);
  if p = 0 then Exit;

  if p = 1 then begin
    F[0].Start := 1;
    F[0].Length := Length(s);
    F[0].Font := green;
  end else begin
    F[0].Start := 1;
    F[0].Length := p - 1;
    F[0].Font := Memo1.Font;
    F[1].Start := p;
    F[1].Length := Length(s) - p;
    F[1].Font := green;
  end;
end;

procedure TCatalogueEditorForm.FormCreate(Sender: TObject);
begin
  purp.Assign(Memo1.Font);
  purp.Color := clPurple;
  green.Assign(Memo1.Font);
  green.Color := clGreen;
end;

initialization
  purp := TFont.Create;
  green := TFont.Create;
  RegisterEditor('Catalogue Files', 'catalogue', 'Catalogue Editor', TCatalogueEditorForm);
finalization
  purp.Free;
  green.Free;
end.
