unit unitMapEditor;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls, Buttons, StdCtrls, Spin, FileCtrl, Registry, ColorGrd, Menus, unitChildForm, BLKClasses, RoomStuff;

type
  TMetaroomEditorForm = class(TMDIChildForm)
    Panel1: TPanel; Panel2: TPanel; SaveDialog1: TSaveDialog; GroupBox1: TGroupBox;
    Label1: TLabel; Label4: TLabel; Label6: TLabel; Label5: TLabel; Label7: TLabel; Label8: TLabel; Label9: TLabel;
    SpeedButton1: TSpeedButton; SpeedButton2: TSpeedButton; ColorGrid1: TColorGrid;
    ComboBox1: TComboBox; ComboBox2: TComboBox; ComboBox3: TComboBox;
    SpinEdit3: TSpinEdit; SpinEdit4: TSpinEdit; SpinEdit5: TSpinEdit; SpinEdit6: TSpinEdit;
    FileListBox1: TFileListBox; ScrollBox1: TScrollBox; PaintBox1: TPaintBox;
    MainMenu1: TMainMenu; Tools1: TMenuItem; SavetoCOSfile1: TMenuItem;
    CheckBox1: TCheckBox; CheckBox2: TCheckBox; CheckBox3: TCheckBox;

    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ColorGrid1Change(Sender: TObject);
    procedure SavetoCOSfile1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SpinEdit5Change(Sender: TObject);
    procedure SpinEdit6Change(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure SpinEdit4Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  public
    blk: TBLKFile;
    mapdata: TMetaRoom;
    moving: boolean; moving_type, moving_room: Integer;

    procedure SyncUp;
    procedure Open(fname: string); override;
    procedure Save; override;
    function IsFileBased: Boolean; override;
  end;

var
  MetaroomEditorForm: TMetaroomEditorForm;
  backdir: string;
  r: TRegistry; // grr =D

implementation

uses Unit1;

{$R *.DFM}

function TMetaroomEditorForm.IsFileBased: Boolean;
begin
  Result := True;
end;

procedure TMetaroomEditorForm.Open(fname: string);
begin
  inherited;

  mapdata.Open(fname);
  SyncUp;
end;

procedure TMetaroomEditorForm.Save;
begin
  mapdata.Save(filename);
end;

procedure TMetaroomEditorForm.SyncUp;
var
  i: Integer;
begin
  ComboBox1.Items.Clear;
  for i := 0 to (mapdata.data.norooms - 1) do
    with mapdata.data.rooms[i] do
      ComboBox1.Items.Add('Room #' + IntToStr(i) + ' - X: ' + IntToStr(left) + ', Y: ' + IntToStr(leftceiling));

  SpinEdit3.Value := mapdata.data.x;
  SpinEdit4.Value := mapdata.data.y;
  SpinEdit5.Value := mapdata.data.width;
  SpinEdit6.Value := mapdata.data.height;

  PaintBox1.Width := mapdata.data.width;
  PaintBox1.Height := mapdata.data.height;

  ComboBox3.ItemIndex := ComboBox3.Items.IndexOf(mapdata.backgroundfile);
  if ComboBox3.ItemIndex <> -1 then ComboBox3Change(Self);
end;

procedure TMetaroomEditorForm.PaintBox1Paint(Sender: TObject);
var
  i: Integer;
begin
  if blk <> nil then if CheckBox3.Checked then blk.Paint(PaintBox1.Canvas);

  PaintBox1.Canvas.Brush.Style := bsClear;
  PaintBox1.Canvas.Pen.Style := psSolid;

  PaintBox1.Canvas.Pen.Color := clGreen;
  PaintBox1.Canvas.Rectangle(0, 0, mapdata.data.width, mapdata.data.height);

  PaintBox1.Canvas.Pen.Color := ColorGrid1.ForegroundColor;
  PaintBox1.Canvas.Font.Color := ColorGrid1.ForegroundColor;

  for i := 0 to (mapdata.data.norooms - 1) do begin
    if i = ComboBox1.ItemIndex then Continue;
    with mapdata.data.rooms[i] do begin
      PaintBox1.Canvas.MoveTo(left, leftceiling);
      PaintBox1.Canvas.LineTo(left, leftfloor);
      PaintBox1.Canvas.LineTo(right, rightfloor);
      PaintBox1.Canvas.LineTo(right, rightceiling);
      PaintBox1.Canvas.LineTo(left, leftceiling);
      PaintBox1.Canvas.TextOut(left, leftceiling, IntToStr(i));

      SetPixel(PaintBox1.Canvas.Handle, left, leftceiling, RGB(0, 255, 0));
      SetPixel(PaintBox1.Canvas.Handle, left, leftfloor, RGB(0, 255, 0));
      SetPixel(PaintBox1.Canvas.Handle, right, rightceiling, RGB(0, 255, 0));
      SetPixel(PaintBox1.Canvas.Handle, right, rightfloor, RGB(0, 255, 0));
    end;
  end;

  PaintBox1.Canvas.Pen.Color := ColorGrid1.BackgroundColor;

  if ComboBox1.ItemIndex <> -1 then
    with mapdata.data.rooms[ComboBox1.ItemIndex] do begin
      PaintBox1.Canvas.MoveTo(left, leftceiling);
      PaintBox1.Canvas.LineTo(left, leftfloor);
      PaintBox1.Canvas.LineTo(right, rightfloor);
      PaintBox1.Canvas.LineTo(right, rightceiling);
      PaintBox1.Canvas.LineTo(left, leftceiling);
      PaintBox1.Canvas.TextOut(left, leftceiling, IntToStr(ComboBox1.ItemIndex));

      SetPixel(PaintBox1.Canvas.Handle, left, leftceiling, RGB(0, 255, 0));
      SetPixel(PaintBox1.Canvas.Handle, left, leftfloor, RGB(0, 255, 0));
      SetPixel(PaintBox1.Canvas.Handle, right, rightceiling, RGB(0, 255, 0));
      SetPixel(PaintBox1.Canvas.Handle, right, rightfloor, RGB(0, 255, 0));
    end;
end;

procedure TMetaroomEditorForm.FormCreate(Sender: TObject);
var
  i: Integer;
  s: string;
begin
  inherited;
  
  mapdata := TMetaRoom.Create;
  blk := nil;

  moving := false;

  // list all the files in the directory
  FileListBox1.Directory := backdir;
  for i := 0 to FileListBox1.Items.Count - 1 do begin
    s := ExtractFileExt(FileListBox1.Items[i]);
    s := Copy(ExtractFileName(FileListBox1.Items[i]), 1, Length(FileListBox1.Items[i]) - Length(s));
    ComboBox3.Items.Add(s);
  end;
end;

procedure TMetaroomEditorForm.FormDestroy(Sender: TObject);
begin
  if blk <> nil then begin blk.Free; blk := nil; end;
//  if mapdata <> nil then begin mapdata.Free; mapdata := nil; end; <-- crashes
end;

procedure TMetaroomEditorForm.ComboBox3Change(Sender: TObject);
begin
  if blk <> nil then blk.Free;

  blk := TBLKFile.Create;
  blk.Open(backdir + ComboBox3.Text + '.blk');
  if not blk.hasdata then begin MessageBeep($FFFFFFFF); {blk.Free;} blk := nil; end;

//  PaintBox1.Width := blk.TotalWidth;
//  PaintBox1.Height := blk.TotalHeight;

  PaintBox1.Refresh;

  mapdata.backgroundfile := ComboBox3.Text;
end;

procedure TMetaroomEditorForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TMetaroomEditorForm.ColorGrid1Change(Sender: TObject);
begin
  PaintBox1.Refresh;
end;

procedure TMetaroomEditorForm.SavetoCOSfile1Click(Sender: TObject);
var
  i: TStringList;
  core: boolean;
  b: Integer;
begin
  i := TStringList.Create;

  if SaveDialog1.Execute then begin
    core := MessageBox(Application.Handle, 'Do you want to generate the new world map code as well (see Fuzzie if you''re going to be using this) (YES), or are you intending this map file to be an addon (NO)?', 'WorldBuilder for Creatures 3', MB_YESNO) = IDYES;
    i.Add('* Generated using WorldBuilder for Creatures 3 ... www.warpedgames.com ... :p');
    i.Add('* neighbours not supported, ignoring');
    i.Add('* room type code not being generated');
    if core then begin
      i.Add('mapk');
      i.Add('brmi 0 0');
      i.Add('mapd 10000 10000');
    end;

    i.Add('setv va00 addm ' + IntToStr(mapdata.data.x) + ' ' + IntToStr(mapdata.data.y) + ' ' + IntToStr(mapdata.data.width) + ' ' + IntToStr(mapdata.data.height) + ' "' + ComboBox3.Text + '"');
    for b := 0 to (mapdata.data.norooms - 1) do begin
      with mapdata.data.rooms[b] do begin
        i.Add('setv va01 addr va00 ' + IntToStr(left + mapdata.data.x) + ' '  + IntToStr(right + mapdata.data.x) + ' '  + IntToStr(leftceiling + mapdata.data.y) + ' ' + IntToStr(rightceiling + mapdata.data.y) + ' ' + IntToStr(leftfloor + mapdata.data.y) + ' ' + IntToStr(rightfloor + mapdata.data.y));
        i.Add('rtyp va01 ' + IntToStr(roomtype));
      end;
    end;

    if core then i.Add('meta 0 -1 -1 0');

    i.SaveToFile(SaveDialog1.filename);
  end;

  i.Free;
end;

procedure TMetaroomEditorForm.ComboBox1Change(Sender: TObject);
begin
  ComboBox2.ItemIndex := mapdata.data.rooms[ComboBox1.ItemIndex].roomtype;
  PaintBox1.Repaint;
end;

procedure TMetaroomEditorForm.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  i: Integer;
begin
  if Button = mbRight then begin
    for i := 0 to (mapdata.data.norooms - 1) do
      with mapdata.data.rooms[i] do
        if X > left then
          if X < right then
            if Y > leftceiling then
              if Y < leftfloor then
                ComboBox1.ItemIndex := i;

    if ComboBox1.ItemIndex <> -1 then
      ComboBox1Change(Self);
  end else if Button = mbLeft then begin
    if CheckBox1.Checked then begin // only edit selected room
      if ComboBox1.ItemIndex = -1 then Exit;
      i := ComboBox1.ItemIndex;
      with mapdata.data.rooms[ComboBox1.ItemIndex] do
        if X = left then if Y = leftceiling then begin
          moving := true; moving_type := 1; moving_room := i; Exit;
        end;
      with mapdata.data.rooms[ComboBox1.ItemIndex] do
        if X = left then if Y = leftfloor then begin
          moving := true; moving_type := 2; moving_room := i; Exit;
        end;
      with mapdata.data.rooms[ComboBox1.ItemIndex] do
        if X = right then if Y = rightceiling then begin
          moving := true; moving_type := 3; moving_room := i; Exit;
        end;
      with mapdata.data.rooms[ComboBox1.ItemIndex] do
        if X = right then if Y = rightfloor then begin
           moving := true; moving_type := 4; moving_room := i; Exit;
        end;
    end else begin
      for i := 0 to (mapdata.data.norooms - 1) do with mapdata.data.rooms[i] do
        if X = left then if Y = leftceiling then begin
          moving := true; moving_type := 1; moving_room := i; Exit;
        end;
      for i := 0 to (mapdata.data.norooms - 1) do with mapdata.data.rooms[i] do
        if X = left then if Y = leftfloor then begin
          moving := true; moving_type := 2; moving_room := i; Exit;
        end;
      for i := 0 to (mapdata.data.norooms - 1) do with mapdata.data.rooms[i] do
        if X = right then if Y = rightceiling then begin
          moving := true; moving_type := 3; moving_room := i; Exit;
        end;
      for i := 0 to (mapdata.data.norooms - 1) do with mapdata.data.rooms[i] do
        if X = right then if Y = rightfloor then begin
           moving := true; moving_type := 4; moving_room := i; Exit;
        end;
    end;
  end;
end;

procedure TMetaroomEditorForm.PaintBox1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  i: Integer;
begin
  if moving then begin
    Screen.Cursor := crCross;
    with mapdata.data.rooms[moving_room] do begin
      if moving_type = 1 then begin
        left := X; leftceiling := Y;
      end else if moving_type = 2 then begin
        left := X; leftfloor := Y;
      end else if moving_type = 3 then begin
        right := X; rightceiling := Y;
      end else if moving_type = 4 then begin
        right := X; rightfloor := Y;
      end;
    end;

    PaintBox1.Invalidate;
  end else begin
    Screen.Cursor := crDefault;
    if CheckBox1.Checked then begin
      if ComboBox1.ItemIndex = -1 then Exit;
      with mapdata.data.rooms[ComboBox1.ItemIndex] do begin
        if X = left then if Y = leftceiling then Screen.Cursor := crCross;
        if X = left then if Y = leftfloor then Screen.Cursor := crCross;
        if X = right then if Y = rightceiling then Screen.Cursor := crCross;
        if X = right then if Y = rightfloor then Screen.Cursor := crCross;
      end;
    end else begin
      for i := 0 to (mapdata.data.norooms - 1) do with mapdata.data.rooms[i] do
        if X = left then if Y = leftceiling then Screen.Cursor := crCross;
      for i := 0 to (mapdata.data.norooms - 1) do with mapdata.data.rooms[i] do
        if X = left then if Y = leftfloor then Screen.Cursor := crCross;
      for i := 0 to (mapdata.data.norooms - 1) do with mapdata.data.rooms[i] do
        if X = right then if Y = rightceiling then Screen.Cursor := crCross;
      for i := 0 to (mapdata.data.norooms - 1) do with mapdata.data.rooms[i] do
        if X = right then if Y = rightfloor then Screen.Cursor := crCross;
    end;
  end;
end;

procedure TMetaroomEditorForm.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  moving := false;
end;

procedure TMetaroomEditorForm.SpinEdit5Change(Sender: TObject);
begin
  mapdata.data.width := SpinEdit5.Value;
  PaintBox1.Width := mapdata.data.width;
end;

procedure TMetaroomEditorForm.SpinEdit6Change(Sender: TObject);
begin
  mapdata.data.height := SpinEdit6.Value;
  PaintBox1.Height := mapdata.data.height;
end;

procedure TMetaroomEditorForm.SpinEdit3Change(Sender: TObject);
begin
  mapdata.data.x := SpinEdit3.Value
end;

procedure TMetaroomEditorForm.SpinEdit4Change(Sender: TObject);
begin
  mapdata.data.y := SpinEdit4.Value;
end;

procedure TMetaroomEditorForm.ComboBox2Change(Sender: TObject);
begin
  mapdata.data.rooms[ComboBox1.ItemIndex].roomtype := ComboBox2.ItemIndex;
end;

procedure TMetaroomEditorForm.CheckBox3Click(Sender: TObject);
begin
  PaintBox1.Invalidate;
end;

procedure TMetaroomEditorForm.SpeedButton1Click(Sender: TObject);
begin
  Inc(mapdata.data.norooms);
  mapdata.data.rooms[mapdata.data.norooms - 1].Left := 15;
  mapdata.data.rooms[mapdata.data.norooms - 1].Right := 30;
  mapdata.data.rooms[mapdata.data.norooms - 1].LeftCeiling := 15;
  mapdata.data.rooms[mapdata.data.norooms - 1].RightCeiling := 15;
  mapdata.data.rooms[mapdata.data.norooms - 1].LeftFloor := 30;
  mapdata.data.rooms[mapdata.data.norooms - 1].RightFloor := 30;

  SyncUp;
end;

procedure TMetaroomEditorForm.SpeedButton2Click(Sender: TObject);
var
  i, j: Integer;
begin
  if ComboBox1.ItemIndex = -1 then Exit;

  j := ComboBox1.ItemIndex;
  for i := j to (mapdata.data.norooms - 2) do begin
    mapdata.data.rooms[i] := mapdata.data.rooms[i + 1];
  end;

  Dec(mapdata.data.norooms);

  SyncUp;
end;

initialization
  RegisterEditor('Metaroom Files', 'mdf', 'Metaroom Editor', TMetaroomEditorForm);

  // fixme: should be game-specific
  // fixme - in fact there should be a game-change callback ala Terminate
  r := TRegistry.Create;
  r.RootKey := HKEY_LOCAL_MACHINE;
  r.OpenKey('Software\Cyberlife Technology\Creatures 3', False);
  backdir := r.ReadString('Backgrounds Directory');
  r.Free;
end.
