unit unitMapViewer;

// the metaroom viewer (from a running session of C3) thingie

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls, StdCtrls, Spin, RoomStuff, unitChildForm, unitErrorHandler;

type
  TMapData = record
    metarooms: array[0..400] of TMetaRoom;
    nometarooms: Integer;
  end;

  TMapViewerForm = class(TMDIChildForm)
    Panel1: TPanel; Label1: TLabel; Label2: TLabel; Label3: TLabel;
    SpinEdit1: TSpinEdit; CheckBox1: TCheckBox; ScrollBox1: TScrollBox; PaintBox1: TPaintBox; SaveDialog1: TSaveDialog;

    procedure FormCreate(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  public
    mapdata: TMapData;
  end;

var
  MapViewerForm: TMapViewerForm;

implementation

uses ZeusClasses;

{$R *.DFM}

function RemoveSpecial(var fromm: string; c: Char): String;
begin
  if pos(c, fromm) = 0 then
  begin
    Result := fromm;
    fromm := '';
    Exit;
  end;
  Result := copy(fromm, 1, pos(c, fromm) - 1);
  fromm := copy(fromm, pos(c, fromm) + 1, length(fromm) - pos(c, fromm));
end;

procedure TMapViewerForm.FormCreate(Sender: TObject);
var
  s1, s2, s3: string;
  i1, i2: Integer;
  metaroom, room: Integer;
  finished, finished2: boolean;
begin
  CommLink.Connect;
  if CommLink.Connected = False then begin
    ErrorDialog(9, True);
    Close;
    Exit;
  end;

  metaroom := 0;

  CommLink.Transaction := 'outv maph'; PaintBox1.Width := StrToInt(CommLink.Results);
  CommLink.Transaction := 'outv mapw'; PaintBox1.Height := StrToInt(CommLink.Results);

  CommLink.Transaction := 'outs emid'; s1 := Trim(CommLink.Results);

  finished := false;
  i1 := 0; // to catch warning
  if s1 = '' then finished := true
  else i1 := StrToInt(RemoveSpecial(s1, ' '));
  while (not finished) do begin
    CommLink.Transaction := 'outs mloc ' + IntToStr(i1); s2 := Trim(CommLink.Results);

    mapdata.metarooms[metaroom] := TMetaRoom.Create;
    mapdata.metarooms[metaroom].data.x := StrToInt(RemoveSpecial(s2, ' '));
    mapdata.metarooms[metaroom].data.y := StrToInt(RemoveSpecial(s2, ' '));
    mapdata.metarooms[metaroom].data.width := StrToInt(RemoveSpecial(s2, ' '));
    mapdata.metarooms[metaroom].data.height := StrToInt(RemoveSpecial(s2, ' '));

    CommLink.Transaction := 'outs bkds ' + IntToStr(i1); s2 := Trim(CommLink.Results);
    mapdata.metarooms[metaroom].backgroundfile := s2;

    CommLink.Transaction := 'outs erid ' + IntToStr(i1); s2 := Trim(CommLink.Results);
    finished2 := false;
    i2 := 0; // to catch warning
    if s2 = '' then finished2 := true
    else i2 := StrToInt(RemoveSpecial(s2, ' '));
    room := 0;
    while (not finished2) do begin
      CommLink.Transaction := 'outs rloc ' + IntToStr(i2); s3 := Trim(CommLink.Results);

      mapdata.metarooms[metaroom].data.rooms[room].left := StrToInt(RemoveSpecial(s3, ' ')) - mapdata.metarooms[metaroom].data.x;
      mapdata.metarooms[metaroom].data.rooms[room].right := StrToInt(RemoveSpecial(s3, ' ')) - mapdata.metarooms[metaroom].data.x;
      mapdata.metarooms[metaroom].data.rooms[room].leftceiling := StrToInt(RemoveSpecial(s3, ' ')) - mapdata.metarooms[metaroom].data.y;
      mapdata.metarooms[metaroom].data.rooms[room].rightceiling := StrToInt(RemoveSpecial(s3, ' ')) - mapdata.metarooms[metaroom].data.y;
      mapdata.metarooms[metaroom].data.rooms[room].leftfloor := StrToInt(RemoveSpecial(s3, ' ')) - mapdata.metarooms[metaroom].data.y;
      mapdata.metarooms[metaroom].data.rooms[room].rightfloor := StrToInt(RemoveSpecial(s3, ' ')) - mapdata.metarooms[metaroom].data.y;

      CommLink.Transaction := 'outv rtyp ' + IntToStr(i2); s3 := Trim(CommLink.Results);

      mapdata.metarooms[metaroom].data.rooms[room].roomtype := StrToInt(s3);

      Inc(room);
      if s2 = '' then finished2 := true
      else i2 := StrToInt(RemoveSpecial(s2, ' '));
    end;

    mapdata.metarooms[metaroom].data.norooms := room;

    Inc(metaroom);
    if s1 = '' then finished := true
    else i1 := StrToInt(RemoveSpecial(s1, ' '));
  end;

  mapdata.nometarooms := metaroom;

  CommLink.Disconnect;
end;

procedure TMapViewerForm.PaintBox1Paint(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to mapdata.nometarooms - 1 do begin
    with mapdata.metarooms[i].data do begin
      PaintBox1.Canvas.Rectangle((x * SpinEdit1.Value) div 100,
                                 (y * SpinEdit1.Value) div 100,
                                 ((width + x) * SpinEdit1.Value) div 100,
                                 ((height + y) * SpinEdit1.Value) div 100);
      if CheckBox1.Checked then begin
      PaintBox1.Canvas.TextOut(((x + (width div 2)) * SpinEdit1.Value) div 100,
                               ((y + (height div 2)) * SpinEdit1.Value) div 100,
                               IntToStr(i) + ' - ' + mapdata.metarooms[i].backgroundfile);
      end else begin
      PaintBox1.Canvas.TextOut(((x + (width div 2)) * SpinEdit1.Value) div 100,
                               ((y + (height div 2)) * SpinEdit1.Value) div 100,
                               IntToStr(i));
      end;
    end;
  end;
end;

procedure TMapViewerForm.SpinEdit1Change(Sender: TObject);
begin
  PaintBox1.Invalidate;
end;

procedure TMapViewerForm.PaintBox1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  i: Integer;
  rx, ry: Integer;
begin
  rx := (X * 100) div SpinEdit1.Value;
  ry := (Y * 100) div SpinEdit1.Value;

  for i := 0 to mapdata.nometarooms - 1 do
    if mapdata.metarooms[i].data.x < rx then
      if mapdata.metarooms[i].data.y < ry then
        if (mapdata.metarooms[i].data.y + mapdata.metarooms[i].data.height) > ry then
          if (mapdata.metarooms[i].data.x + mapdata.metarooms[i].data.width) > rx then begin
            SaveDialog1.Filename := mapdata.metarooms[i].backgroundfile + '.mdf';
            if SaveDialog1.Execute then begin
              mapdata.metarooms[i].Save(SaveDialog1.Filename);
            end;
          end;
end;

procedure TMapViewerForm.FormDestroy(Sender: TObject);
begin
  MapViewerForm := nil;
end;

procedure TMapViewerForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

initialization
  MapViewerForm := nil;
end.
