unit Unit1;

// TZeusMainForm : Main Form

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Menus, ToolWin, ComCtrls, ExtCtrls, unitChildForm, unitErrorHandler,
  ImgList;

type
  TZeusMainForm = class(TForm)
    ZeusMainMenu: TMainMenu; StatusBar1: TStatusBar;

    // Note: many of these menu items are hidden.
    // Double-click on ZeusMainMenu in Delphi to view the whole menu.
    File1: TMenuItem; Edit1: TMenuItem; View1: TMenuItem; Workspace1: TMenuItem;
    Game1: TMenuItem; Help1: TMenuItem; New1: TMenuItem; Open1: TMenuItem;
    Save1: TMenuItem; SaveAs1: TMenuItem; Close1: TMenuItem; N1: TMenuItem;
    RecentFiles1: TMenuItem; N2: TMenuItem; Exit1: TMenuItem; SaveAll1: TMenuItem;
    CloseAll1: TMenuItem; Undo1: TMenuItem; Redo1: TMenuItem; N3: TMenuItem;
    Cut1: TMenuItem; Copy1: TMenuItem; Paste1: TMenuItem; Delete1: TMenuItem;
    SelectAll1: TMenuItem; N4: TMenuItem; Find1: TMenuItem; FindandReplace1: TMenuItem; NewWorkspace1: TMenuItem;
    OpenWorkspace1: TMenuItem; SaveWorkspace1: TMenuItem; SaveWorkspaceAs1: TMenuItem; CloseWorkspace1: TMenuItem;
    N7: TMenuItem; RecentWorkspaces1: TMenuItem; HelpTopics1: TMenuItem; HelponGAME1: TMenuItem;
    N8: TMenuItem; AboutZeus1: TMenuItem; Print1: TMenuItem; PrinterSetup1: TMenuItem;
    N9: TMenuItem; Welcome1: TMenuItem; dummy1: TMenuItem;
    Window1: TMenuItem; Cascade1: TMenuItem; TileHorizontally1: TMenuItem; TileVertically1: TMenuItem; ArrangeIcons1: TMenuItem;

    OpenDialog1: TOpenDialog; FindDialog1: TFindDialog; ReplaceDialog1: TReplaceDialog; PrintDialog1: TPrintDialog; PrinterSetupDialog1: TPrinterSetupDialog;
    MenuImages: TImageList;
    PanelDockTop: TPanel;
    TopSplitter: TSplitter;
    PanelDockLeft: TPanel;
    LeftSplitter: TSplitter;
    CAOSReference1: TMenuItem;

    procedure Open1Click(Sender: TObject);
    procedure Find1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure PrinterSetup1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure AboutZeus1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Game1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure FindandReplace1Click(Sender: TObject);
    procedure File1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure ToolbarButton972Click(Sender: TObject);
    procedure ToolbarButton973Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Welcome1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure HelpTopics1Click(Sender: TObject);
    procedure HelponGAME1Click(Sender: TObject);
    procedure CloseAll1Click(Sender: TObject);
    procedure SaveAll1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure ArrangeIcons1Click(Sender: TObject);
    procedure TileHorizontally1Click(Sender: TObject);
    procedure TileVertically1Click(Sender: TObject);
    procedure PanelDockDrop(Sender: TObject;
      Source: TDragDockObject; X, Y: Integer);
    procedure PanelUnDock(Sender: TObject; Client: TControl;
      NewTarget: TWinControl; var Allow: Boolean);
    procedure CAOSReference1Click(Sender: TObject);
    procedure View1Click(Sender: TObject);
  public
    procedure GameSelectClick(Sender: TObject);
    procedure RecentFileClick(Sender: TObject);
    procedure AddRecentFile(n: string);
    procedure OpenFile(z: string);

    procedure ShowDockPanel(APanel: TPanel; MakeVisible: Boolean; Client: TControl);
  end;

var
  ZeusMainForm: TZeusMainForm;
  filter: string;
  editors, ftypes: TStringList;
  recentfiles: TStringList;
  newfilef, aboutf, welcf: TForm; // fiddle ... we can't include unitNewFileForm, because it makes the other
                      // units initialization clauses exec before this, which messes up our system =(

procedure RegisterEditor(filetype, fileext, editorname: string; formtype: TChildClass);

implementation

uses Registry, ZeusClasses, unitSplahScreen, unitCAOSReference;

{$R *.DFM}

procedure TZeusMainForm.OpenFile(z: string);
var
  i: Integer; s: string;
  x: TChildClass; p: TMDIChildForm;
begin
  if not FileExists(z) then Exit;
  
  s := LowerCase(ExtractFileExt(z));
  s := Copy(s, 2, Length(s) - 1);
  i := ftypes.IndexOf(s);
  if i = -1 then begin
    Application.MessageBox(PChar('Zeus doesn''t know how to open file ' + s + '! - this kind of file is unknown!'), 'Zeus', MB_OK + MB_ICONWARNING);
    Exit;
  end;
  x := TChildClass(ftypes.objects[i]);
  p := x.Create(Self);
  p.Open(z);

  AddRecentFile(z);
end;

procedure TZeusMainForm.AddRecentFile(n: string);
var
  i: Integer;
begin
  // muhwahahaha =PPP
  n := LowerCase(n);
  i := recentfiles.IndexOf(n);
  while i <> -1 do begin
    recentfiles.Delete(i);
    // remove multiple entries too... :)
    i := recentfiles.IndexOf(n);
  end;
  recentfiles.Insert(0, n);
  while recentfiles.Count > 8 do
    recentfiles.Delete(8);
  while recentfiles.Count < 8 do
    recentfiles.Add('');
end;

procedure TZeusMainForm.Open1Click(Sender: TObject);
var
  s: string; i: Integer;
begin
  s := '';
  for i := 0 to (ftypes.Count - 1) do begin
    s := s + '*.' + ftypes[i] + ';'
  end;

  OpenDialog1.Filter := 'All Zeus Files|' + s + '|' + filter;
  if not OpenDialog1.Execute then Exit;

  OpenFile(OpenDialog1.Filename);
end;

procedure TZeusMainForm.Find1Click(Sender: TObject);
begin
  FindDialog1.Execute;
end;

procedure TZeusMainForm.Print1Click(Sender: TObject);
begin
  if not PrintDialog1.Execute then Exit;
end;

procedure TZeusMainForm.PrinterSetup1Click(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TZeusMainForm.SaveAs1Click(Sender: TObject);
begin
  Assert(ActiveMDIChild is TMDIChildForm, 'ActiveMDIChild is TMDIChildForm');

  with ActiveMDIChild as TMDIChildForm do SaveAs;
end;

procedure TZeusMainForm.AboutZeus1Click(Sender: TObject);
begin
  Aboutf.ShowModal;
end;

procedure TZeusMainForm.FormCreate(Sender: TObject);
var
  rr: TRegistry; i: TMenuItem;
  j: Integer; s: TStringList;
begin
  // enumerate the games
  rr := TRegistry.Create;
  rr.RootKey := HKEY_LOCAL_MACHINE;

  if rr.OpenKey('\Software\Millennium Interactive\Creatures\1.0', False) then begin
    i := TMenuItem.Create(Self);
    i.Caption := 'Creatures 1';
    i.OnClick := GameSelectClick;
    Game1.Add(i);
  end;

  if rr.OpenKey('\Software\Cyberlife Technology', False) then
    if rr.HasSubKeys then begin
      s := TStringList.Create;
      rr.GetKeyNames(s);

      for j := 0 to (s.count - 1) do begin
        i := TMenuItem.Create(Self);
        i.Caption := s[j];
        i.OnClick := GameSelectClick;
        Game1.Add(i);
      end;

      s.Free;
    end;

  if Game1.Count = 0 then begin
    Application.MessageBox('You don''t have any Creatures games installed (or else they''re not installed correctly) - while you can use Zeus without any Creatures games installed, it isn''t much use ;)', 'Zeus', MB_OK + MB_ICONINFORMATION);
    i := TMenuItem.Create(Self);
    i.Caption := 'None';
    i.Enabled := False;
    Game1.Add(i);
  end;
end;

procedure TZeusMainForm.Game1Click(Sender: TObject);
var
  i: Integer;
begin
  // enumerate menu items below us, check for match with CommLink.GameName

  for i := 0 to (Game1.Count - 1) do begin
    Game1.Items[i].Checked := Game1.Items[i].Caption = CommLink.GameName;
  end;
end;

procedure TZeusMainForm.GameSelectClick(Sender: TObject);
begin
  with Sender as TMenuItem do
    CommLink.GameName := Caption;
  SyntaxDataUpdate;
end;

procedure RegisterEditor(filetype, fileext, editorname: string; formtype: TChildClass);
begin
  try
    filter := filetype + ' (*.' + fileext + ')|*.' + fileext + '|' + filter;

    // editors is used by New, set the editor name to '' to avoid New
    if editorname <> '' then begin
      editors.Add(editorname);
      editors.Objects[editors.Count - 1] := TObject(formtype);
    end;

    ftypes.Add(fileext);
    ftypes.Objects[ftypes.Count - 1] := TObject(formtype);
  except
    on Exception do MessageBox(0, 'RegisterEditor caught an exception! An initialization clause must be executing before the Unit1 initialization clause! This is a coding fault ... see the Maintenance section of the project paper for information.', 'Zeus', MB_OK + MB_ICONWARNING);
  end;
end;

procedure TZeusMainForm.RecentFileClick(Sender: TObject);
begin
  with Sender as TMenuItem do
    OpenFile(Hint);
end;

procedure TZeusMainForm.Save1Click(Sender: TObject);
begin
  Assert(ActiveMDIChild is TMDIChildForm, 'ActiveMDIChild is TMDIChildForm');

  with ActiveMDIChild as TMDIChildForm do Save;
end;

procedure TZeusMainForm.FindandReplace1Click(Sender: TObject);
begin
  ReplaceDialog1.Execute;
end;

procedure TZeusMainForm.File1Click(Sender: TObject);
var
  i: TMenuItem; j: Integer;
begin
  while RecentFiles1.Count > 0 do
    RecentFiles1.Delete(0);

  for j := 0 to 7 do begin
    if recentfiles[j] <> '' then begin
      i := TMenuItem.Create(Self);
      i.Caption := IntToStr(j) + ' ' + recentfiles[j];
      i.Hint := recentfiles[j];
      i.OnClick := RecentFileClick;
      RecentFiles1.Add(i);
    end;
  end;
  if RecentFiles1.Count = 0 then begin
    i := TMenuItem.Create(Self);
    i.Caption := 'None';
    i.Enabled := False;
    RecentFiles1.Add(i);
  end;

  if not (ActiveMDIChild is TMDIChildForm) then begin
    ErrorDialog(11, True); Free;
  end;

  with ActiveMDIChild as TMDIChildForm do begin
    Save1.Enabled := IsFileBased;
    SaveAs1.Enabled := Save1.Enabled;
    Close1.Enabled := True;
    Print1.Enabled := CanPrint;
  end;
end;

procedure TZeusMainForm.Close1Click(Sender: TObject);
begin
  if ActiveMDIChild <> nil then ActiveMDIChild.Close;
end;

procedure TZeusMainForm.ToolbarButton972Click(Sender: TObject);
begin
  Open1.OnClick(Sender);
end;

procedure TZeusMainForm.ToolbarButton973Click(Sender: TObject);
begin
  New1.OnClick(Sender);
end;

procedure TZeusMainForm.New1Click(Sender: TObject);
begin
  newfilef.ShowModal;
end;

procedure TZeusMainForm.Welcome1Click(Sender: TObject);
begin
  welcf.ShowModal;
end;

procedure TZeusMainForm.Help1Click(Sender: TObject);
begin
  HelpOnGame1.Caption := 'Help on ' + CommLink.GameName + '...';
end;

procedure TZeusMainForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TZeusMainForm.HelpTopics1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTENTS, 0);
end;

procedure TZeusMainForm.HelponGAME1Click(Sender: TObject);
begin
  Application.MessageBox('Game-specific help is not implemented at this time.', 'Zeus', MB_OK + MB_ICONERROR);
end;

procedure TZeusMainForm.CloseAll1Click(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to (MDIChildCount - 1) do begin
    MDIChildren[i].Close;
  end;
end;

procedure TZeusMainForm.SaveAll1Click(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to (MDIChildCount - 1) do
    if MDIChildren[i] is TMDIChildForm then
      with MDIChildren[i] as TMDIChildForm do
        if IsFileBased then Save;
end;

procedure TZeusMainForm.Cascade1Click(Sender: TObject);
begin
  Cascade;
end;

procedure TZeusMainForm.ArrangeIcons1Click(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TZeusMainForm.TileHorizontally1Click(Sender: TObject);
begin
  TileMode := tbHorizontal;
  Tile;
end;

procedure TZeusMainForm.TileVertically1Click(Sender: TObject);
begin
  TileMode := tbVertical;
  Tile;
end;

procedure TZeusMainForm.ShowDockPanel(APanel: TPanel; MakeVisible: Boolean; Client: TControl);
begin
  // Client - the docked client to show if we are re-showing the panel.
  // Client is ignored if hiding the panel.

  // Since docking to a non-visible docksite isn't allowed, instead of setting
  // Visible for the panels we set the width to zero. The default InfluenceRect
  // for a control extends a few pixels beyond it's boundaries, so it is possible
  // to dock to zero width controls.

  // Don't try to hide a panel which has visible dock clients.
  if not MakeVisible and (APanel.VisibleDockClientCount > 1) then
    Exit;

  if APanel = PanelDockLeft then
    LeftSplitter.Visible := MakeVisible
  else
    TopSplitter.Visible := MakeVisible;

  if MakeVisible then begin
    if APanel = PanelDockLeft then begin
      APanel.Width := ClientWidth div 3;
      LeftSplitter.Left := APanel.Width + LeftSplitter.Width;
    end else begin
      APanel.Height := ClientHeight div 3;
      TopSplitter.Top := APanel.Height + TopSplitter.Height;
    end;
  end else begin
    if APanel = PanelDockLeft then
      APanel.Width := 0
    else
      APanel.Height := 0;
  end;

  if MakeVisible and (Client <> nil) then Client.Show;
end;

procedure TZeusMainForm.PanelDockDrop(Sender: TObject; Source: TDragDockObject; X, Y: Integer);
begin
  if (Sender as TPanel).DockClientCount = 1 then
    ShowDockPanel(Sender as TPanel, True, nil);
  (Sender as TPanel).DockManager.ResetBounds(True);
end;

procedure TZeusMainForm.PanelUnDock(Sender: TObject; Client: TControl; NewTarget: TWinControl; var Allow: Boolean);
begin
  if (Sender as TPanel).DockClientCount = 1 then
    ShowDockPanel(Sender as TPanel, False, nil);
end;

procedure TZeusMainForm.CAOSReference1Click(Sender: TObject);
begin
  if CAOSRefForm.Visible then begin
    CAOSRefForm.Close;
    Exit;
  end;

  with CAOSRefForm do
    if (HostDockSite is TPanel) and ((HostDockSite.Height = 0) or (HostDockSite.Width = 0)) then
      ShowDockPanel(HostDockSite as TPanel, True, CAOSRefForm)
    else
      Show;
end;

procedure TZeusMainForm.View1Click(Sender: TObject);
begin
  CAOSReference1.Checked := CAOSRefForm.Visible;
end;

initialization
  Application.Initialize;
  Application.Title := 'Zeus';
  Application.HelpFile := 'zeus.hlp';

  Application.CreateForm(TZeusMainForm, ZeusMainForm);
  Application.CreateForm(TSplashForm, SplashForm);
  SplashForm.Show; SplashForm.Refresh;

  filter := 'All Files (*.*)|*.*';
  editors := TStringList.Create;
  ftypes := TStringList.Create;
  recentfiles := TStringList.Create;
finalization
  editors.Free;
  ftypes.Free;
  recentfiles.Free;
end.
