unit unitChildForm; // aka the world of insane comments

// TMDIChildForm : Shared MDI Child Form Class

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type // a bunch of stuff
  TMDIChildForm = class(TForm)
    SaveDialogStd: TSaveDialog;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
  public
    modified: Boolean; // have we been modified? probably, you know wha users are like
    ctypename, filename: string; // hmm .. the name! and another name!
    function IsFileBased: Boolean; virtual; // are we insane?
    function CanPrint: Boolean; virtual; // can we print ze file?

    procedure New; virtual; // make ze new file
    procedure Open(fname: string); virtual; // open ze existing file
    procedure Save; virtual; abstract; // save ze file
    procedure SaveAs; // save ze file as another file
    procedure Print; virtual; abstract; // print ze file
  end;

  TChildClass = class of TMDIChildForm;

var
  MDIChildForm: TMDIChildForm; // us again! we don't use this, but Delphi likes it being here

implementation

uses Unit1;

{$R *.DFM} // include da resources which we can load ze form from

// Return whether we can print our data or not. Descendants which support printing
// will override this.
function TMDIChildForm.CanPrint: Boolean;
begin
  Result := False;
end;

function TMDIChildForm.IsFileBased: Boolean;
begin
  // hmm, are we file based? us? my good man, surely you jest!
  // you think Fuzzie can program a file-based program or sommat? =)
  Result := False; // the answer is no ... muhwahahahahaha!
end;

// New just does a few standard things. It might be overriden by descendants.
procedure TMDIChildForm.New;
begin
  // make a new file - otherwise known as do lots of pretty things which aren't in the least bit useful
  filename := '';
  modified := false;
  caption := 'Untitled - ' + ctypename;
end;

// Open just does a few standard things. It will be overriden by descendants.
procedure TMDIChildForm.Open(fname: string);
begin
  filename := fname;
  modified := false;
  Caption := ExtractFileName(fname) + ' - ' + ctypename;
end;

// the standard savedialogstd filter is *.*
// children should change this in their OnCreate - as well as typename
procedure TMDIChildForm.SaveAs;
begin
  // hmm ... well, this is called 'saving as' and its very pretty
  if SaveDialogStd.Execute then begin
    ZeusMainForm.AddRecentFile(SaveDialogStd.Filename);
    filename := SaveDialogStd.filename;
    Save;
  end;
end;

// FormClose - just make sure the form is freed, the Delphi VCL's default
// behaviour is to minimize the window...
procedure TMDIChildForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

// FormCloseQuery - check if we've been modified or not ... if we have, ask
// the user if they want to save the file before the window is closed - give
// them a choice to cancel too, they may have clicked close by mistake.
procedure TMDIChildForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
  b: Cardinal;
begin
  if not modified then Exit;

  if filename = '' then
    b := MessageBox(Application.Handle, 'Do you want to save untitled?','Zeus', MB_YESNOCANCEL)
  else
    b := MessageBox(Application.Handle, PChar('Do you want to save ' + filename + '?'),'Zeus', MB_YESNOCANCEL);
  if b = IDYES then Save;
  if b = IDCANCEL then CanClose := False;
end;

procedure TMDIChildForm.FormCreate(Sender: TObject);
begin
  ctypename := Caption;
end;

end. // of the insane comments ... for now
