unit unitErrorHandler;

interface

uses Forms, SysUtils, Windows, Classes;

procedure ErrorRaiseException(errno: Integer);
procedure ErrorDialog(errno: Integer; error: Boolean);

const
  appname = 'Zeus';

var
  errs: TStringList;

implementation

procedure ErrorRaiseException(errno: Integer);
var
  s: string;
begin
  FmtStr(s, 'X%.4d: ', [errno]);
  if (errno < 0) or (errno > errs.Count) then
    s := s + 'Message not found'
  else
    s := s + errs[errno];

  raise Exception.Create(s);
end;

procedure ErrorDialog(errno: Integer; error: Boolean);
var
  s: string;
begin
  FmtStr(s, 'E%.4d: ', [errno]);
  if (errno < 0) or (errno > errs.Count) then
    s := s + 'Message not found'
  else
    s := s + errs[errno];

  if error then Application.MessageBox(PChar(s), appname, MB_OK + MB_ICONERROR)
  else Application.MessageBox(PChar(s), appname, MB_OK + MB_ICONEXCLAMATION);
end;

initialization
  errs := TStringList.Create;
  { 0 } errs.Add('The file you are attempting to open isn''t a COB file.');
  { 1 } errs.Add('There is more than one import in this Creatures 1 COB file. Only one import will be loaded.');
  { 2 } errs.Add('zLib: uncompress: inflateInit failed!');
  { 3 } errs.Add('zLib: uncompress: inflate failed, not at stream end!');
  { 4 } errs.Add('zLib: compress() failed, the output file will be corrupted. Try again without compression.');
  { 5 } errs.Add('This file is not a PRAY file.');
  { 6 } errs.Add('Cannot allocate source memory for block.');
  { 7 } errs.Add('Cannot allocate destination memory for block.');
  { 8 } errs.Add('Couldn''t open background file. Another program may have an exclusive lock on it (eg Creatures 3). Close that application, and try again.');
  { 9 } errs.Add('Cannot open a connection to a running copy of Creatures. Please make sure a copy of Creatures is running and that the right game is selected.');
  { 10 } errs.Add('The thumbnail has to be an S16 or C16 file!');
  { 11 } errs.Add('Internal Error: MDI Child isn''t TMDIChildForm descendant!');
  { 12 } errs.Add('TS16File::LoadFromS16: out of memory!');
  { 13 } errs.Add('TPrayDecompilerForm::New: PRAY file creation not supported yet!');
  { 14 } errs.Add('Internal error: color-coding <> tokenising out of sync');
  { 15 } errs.Add('This part of ' + appname + ' hasn''t been implemented yet! If you get this in a release version, moan at Fuzzie!');
  { 16 } errs.Add('SplitScriptStrings: There can be no commands between ENDM and the next SCRP/ISCR/RSCR.');
  { 17 } errs.Add('Internal error: j reached 1000 in SyntaxCheck internal loop!');
  { 18 } errs.Add('SyntaxCheckTokenSet::ParseKeyword got non-keyword!');
  { 19 } errs.Add('SyntaxCheckTokenSet::ParseKeyword got command which is non-keyword!');
  { 20 } errs.Add('BLK file doesn''t exist.');
finalization
  errs.Free;
end.
